<?php     
if (isset($_SESSION['adminid']) && isset($_REQUEST['id']) && basename($_SERVER["SCRIPT_FILENAME"], '.php') == 'configproducts') {
    require_once 'Helper.php';
    ob_clean();

    if($_POST['action'] == 'serverTasticToken_setup_configurable_options') {
        if (\ServerTasticToken\Helper::customFieldExists($_REQUEST['id'], 'token')) {
            die(json_encode(array('success' => 0, 'result' => 'Product has already required custom field.')));
        } else {
            \ServerTasticToken\Helper::createTokenCustomField($_REQUEST['id']);
            die(json_encode(array('success' => 1, 'result' => 'Generated custom field for product')));
        }
    } elseif($_POST['action'] == 'serverTasticToken_setup_email_template') {
        $error = true;
        foreach(\ServerTasticToken\Helper::emailTemplateExists() as $templateName => $exist)
        {
            if($exist == false)
            {
                switch ($templateName)
                {
                    case \ServerTasticToken\Helper::TEMPLATE_NAME:
                        \ServerTasticToken\Helper::createEmailTemplate();
                        break;
                    case \ServerTasticToken\Helper::CERT_EXPIRATION_TEMPLATE_NAME:
                        \ServerTasticToken\Helper::createCertExpirationEmailTemplate();
                        break;
                }
                $error = false;
            }
        }
        if(!$error) {
            die(json_encode(array('success' => 1, 'result' => 'Generated Email Template')));
        } else {
            die(json_encode(array('success' => 0, 'result' => 'Email Template already exists')));
        }
    }
}


if(!function_exists('serverTasticExpirationRemind'))
{
    function serverTasticExpirationRemind()
    {
        try
        {  
            GLOBAL $CONFIG;
            
            require_once 'API.php';
            require_once 'Helper.php';      
            require_once 'Services/EmailService.php';    
            ob_clean();

            //remind on day before expiration
            $remindDays = [30, 14, 7]; 
            
            //get all active servertastic token orders
            $orders = \ServerTasticToken\Helper::getServerTasticOrders();
            
            $today = time();
            
            foreach ($orders as $order)
            {         
                $api = new ServerTasticToken\API($order->api_key, isset($order->test_mode) ? ($order->test_mode == 'on' ? true : false) : false);
                //get info from API for given token
                $info = $api->tokenInfo($order->order_token);
                
                //if certificate_list is empty skip to next orders item
                if(empty($info->certificate_list))
                    continue;

                $certificate = $info->certificate_list[0];
                
                //get number of days to expire
                $certExpirationDate = $certificate->expiration_date;
                $timeDiff           = abs(strtotime($certExpirationDate) - $today);
                $numberDays         = floor($timeDiff / 86400) + 1;
                
                //check if retrived number day is remind number
                if(in_array($numberDays, $remindDays))
                {
                    //get remind email template name
                    $messageName = \ServerTasticToken\Helper::CERT_EXPIRATION_TEMPLATE_NAME;  
                    //prepare custom template vars                    
                    $fieldsToMerge = [
                        'expiration_date'  =>  $certExpirationDate,
                        'token_order_url'  =>  $CONFIG["SystemURL"] . '/cart.php?a=add&pid=' . $order->product_id,
                    ];                    
                    //send email
                    \ServerTasticToken\Services\EmailService::sendEmail($messageName, $order->service_id, $fieldsToMerge);                   
                }                
            }
        }
        catch (Exception $ex)
        {
            logActivity('[Daily Cron - ServerTastic Token Reminder] error: ' . $ex->getMessage());
        }
    }
}
add_hook('DailyCronJob', 1, 'serverTasticExpirationRemind');
